Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_Strategy_Connector Class Template Reference

Abstract factory for creating a service handler (SVC_HANDLER), connecting the SVC_HANDLER, and activating the SVC_HANDLER. More...

`#include <Connector.h>`

Inheritance diagram for ACE_Strategy_Connector:

[legend]
Collaboration diagram for ACE_Strategy_Connector:

[legend]
List of all members.

## Public Types
typedef ACE_Creation_Strategy< SVC_HANDLER > | CREATION_STRATEGY
typedef ACE_Connect_Strategy< SVC_HANDLER, ACE_PEER_CONNECTOR_2 > | CONNECT_STRATEGY
typedef ACE_Concurrency_Strategy< SVC_HANDLER > | CONCURRENCY_STRATEGY
typedef ACE_Connector< SVC_HANDLER, ACE_PEER_CONNECTOR_2 > | SUPER
## Public Methods
| ACE_Strategy_Connector (ACE_Reactor *r=ACE_Reactor::instance(), ACE_Creation_Strategy< SVC_HANDLER > *=0, ACE_Connect_Strategy< SVC_HANDLER, ACE_PEER_CONNECTOR_2 > *=0, ACE_Concurrency_Strategy< SVC_HANDLER > *=0, int flags=0)
| Initialize a connector. More...
virtual int | open (ACE_Reactor *r, int flags)
| Initialize a connector. More...
virtual int | open (ACE_Reactor *r=ACE_Reactor::instance(), ACE_Creation_Strategy< SVC_HANDLER > *=0, ACE_Connect_Strategy< SVC_HANDLER, ACE_PEER_CONNECTOR_2 > *=0, ACE_Concurrency_Strategy< SVC_HANDLER > *=0, int flags=0)
| Initialize a connector. More...
virtual | ~ACE_Strategy_Connector (void)
| Shutdown a connector and release resources. More...
virtual int | close (void)
| Close down the Connector. More...
virtual ACE_Creation_Strategy< SVC_HANDLER > * | creation_strategy (void) const
virtual ACE_Connect_Strategy< SVC_HANDLER, ACE_PEER_CONNECTOR_2 > * | connect_strategy (void) const
virtual ACE_Concurrency_Strategy< SVC_HANDLER > * | concurrency_strategy (void) const
## Protected Methods
virtual int | make_svc_handler (SVC_HANDLER *&sh)
| Bridge method for creating a <SVC_HANDLER>. More...
virtual int | connect_svc_handler (SVC_HANDLER *&sh, const ACE_PEER_CONNECTOR_ADDR &remote_addr, ACE_Time_Value *timeout, const ACE_PEER_CONNECTOR_ADDR &local_addr, int reuse_addr, int flags, int perms)
| Bridge method for connecting the new connection into the <SVC_HANDLER>. More...
virtual int | connect_svc_handler (SVC_HANDLER *&sh, SVC_HANDLER *&sh_copy, const ACE_PEER_CONNECTOR_ADDR &remote_addr, ACE_Time_Value *timeout, const ACE_PEER_CONNECTOR_ADDR &local_addr, int reuse_addr, int flags, int perms)
| Bridge method for connecting the new connection into the <SVC_HANDLER>. More...
virtual int | activate_svc_handler (SVC_HANDLER *svc_handler)
| Bridge method for activating a <SVC_HANDLER> with the appropriate concurrency strategy. More...
## Protected Attributes
CREATION_STRATEGY * | creation_strategy_
| Creation strategy for an <Connector>. More...
int | delete_creation_strategy_
| 1 if <Connector> created the creation strategy and thus should delete it, else 0. More...
CONNECT_STRATEGY * | connect_strategy_
| Connect strategy for a <Connector>. More...
int | delete_connect_strategy_
| 1 if <Connector> created the connect strategy and thus should delete it, else 0. More...
CONCURRENCY_STRATEGY * | concurrency_strategy_
| Concurrency strategy for an <Connector>. More...
int | delete_concurrency_strategy_
| 1 if <Connector> created the concurrency strategy and thus should delete it, else 0. More...

## Detailed Description

### template<class SVC_HANDLER, ACE_PEER_CONNECTOR_1>
class ACE_Strategy_Connector< SVC_HANDLER, >

Abstract factory for creating a service handler (SVC_HANDLER), connecting the SVC_HANDLER, and activating the SVC_HANDLER.

Implements a flexible and extensible set of strategies for actively establishing connections with clients. There are three main strategies: (1) creating a SVC_HANDLER, (2) actively initiating a new connection from the client, and (3) activating the SVC_HANDLER with a particular concurrency mechanism after the connection is established.

## Member Typedef Documentation

template<class SVC_HANDLER, ACE_PEER_CONNECTOR_1 >
typedef ACE_Concurrency_Strategy<SVC_HANDLER> ACE_Strategy_Connector::CONCURRENCY_STRATEGY

template<class SVC_HANDLER, ACE_PEER_CONNECTOR_1 >
typedef ACE_Connect_Strategy<SVC_HANDLER, ACE_PEER_CONNECTOR_2> ACE_Strategy_Connector::CONNECT_STRATEGY

template<class SVC_HANDLER, ACE_PEER_CONNECTOR_1 >
typedef ACE_Creation_Strategy<SVC_HANDLER> ACE_Strategy_Connector::CREATION_STRATEGY

template<class SVC_HANDLER, ACE_PEER_CONNECTOR_1 >
typedef ACE_Connector<SVC_HANDLER, ACE_PEER_CONNECTOR_2> ACE_Strategy_Connector::SUPER

## Constructor & Destructor Documentation

template<class SVC_HANDLER, ACE_PEER_CONNECTOR_1 >
ACE_Strategy_Connector< SVC_HANDLER, >::ACE_Strategy_Connector | ( | ACE_Reactor * | r = ACE_Reactor::instance (),
|  | ACE_Creation_Strategy< SVC_HANDLER > * | = 0,
|  | ACE_Connect_Strategy< SVC_HANDLER, ACE_PEER_CONNECTOR_2 > * | = 0,
|  | ACE_Concurrency_Strategy< SVC_HANDLER > * | = 0,
|  | int | flags = 0
| ) |

| Initialize a connector. <flags> indicates how <SVC_HANDLER>'s should be initialized prior to being activated. Right now, the only flag that is processed is <ACE_NONBLOCK>, which enabled non-blocking I/O on the <SVC_HANDLER> when it is opened.

template<class SVH, PR_CO_1 >
ACE_Strategy_Connector< SVH, >::~ACE_Strategy_Connector | ( | void |  | ) | `[virtual]`

| Shutdown a connector and release resources.

## Member Function Documentation

template<class SVC_HANDLER, ACE_PEER_CONNECTOR_1 >
virtual int ACE_Strategy_Connector< SVC_HANDLER, >::activate_svc_handler | ( | SVC_HANDLER * | svc_handler | ) | `[protected, virtual]`

| Bridge method for activating a <SVC_HANDLER> with the appropriate concurrency strategy. The default behavior of this method is to activate the <SVC_HANDLER> by calling its <open> method (which allows the <SVC_HANDLER> to define its own concurrency strategy). However, subclasses can override this strategy to do more sophisticated concurrency activations (such as creating the <SVC_HANDLER> as an "active object" via multi-threading or multi-processing). Reimplemented from ACE_Connector.

template<class SVH, PR_CO_1 >
int ACE_Strategy_Connector< SVH, >::close | ( | void |  | ) | `[virtual]`

| Close down the Connector. Reimplemented from ACE_Connector.

template<class SVH, PR_CO_1 >
ACE_Concurrency_Strategy< SVC_HANDLER > * ACE_Strategy_Connector< SVH, >::concurrency_strategy | ( | void |  | ) | const`[virtual]`

template<class SVH, PR_CO_1 >
ACE_Connect_Strategy< SVC_HANDLER, ACE_PEER_CONNECTOR_2 > * ACE_Strategy_Connector< SVH, >::connect_strategy | ( | void |  | ) | const`[virtual]`

template<class SVH, PR_CO_1 >
int ACE_Strategy_Connector< SVH, >::connect_svc_handler | ( | SVH *& | sh,
|  | SVH *& | sh_copy,
|  | const ACE_PEER_CONNECTOR_ADDR & | remote_addr,
|  | ACE_Time_Value * | timeout,
|  | const ACE_PEER_CONNECTOR_ADDR & | local_addr,
|  | int | reuse_addr,
|  | int | flags,
|  | int | perms
| ) | `[protected, virtual]`

| Bridge method for connecting the new connection into the <SVC_HANDLER>. The default behavior delegates to the <PEER_CONNECTOR::connect> in the <Connect_Strategy>. <sh_copy> is used to obtain a copy of the <sh> pointer, but that can be kept in the stack; the motivation is a bit too long to include here, but basically we want to modify <sh> safely, using the internal locks in the Connect_Strategy, while saving a TSS copy in <sh_copy>, usually located in the stack.

template<class SVH, PR_CO_1 >
int ACE_Strategy_Connector< SVH, >::connect_svc_handler | ( | SVH *& | sh,
|  | const ACE_PEER_CONNECTOR_ADDR & | remote_addr,
|  | ACE_Time_Value * | timeout,
|  | const ACE_PEER_CONNECTOR_ADDR & | local_addr,
|  | int | reuse_addr,
|  | int | flags,
|  | int | perms
| ) | `[protected, virtual]`

| Bridge method for connecting the new connection into the <SVC_HANDLER>. The default behavior delegates to the <PEER_CONNECTOR::connect> in the <Connect_Strategy>.

template<class SVH, PR_CO_1 >
ACE_Creation_Strategy< SVC_HANDLER > * ACE_Strategy_Connector< SVH, >::creation_strategy | ( | void |  | ) | const`[virtual]`

template<class SVC_HANDLER, ACE_PEER_CONNECTOR_1 >
virtual int ACE_Strategy_Connector< SVC_HANDLER, >::make_svc_handler | ( | SVC_HANDLER *& | sh | ) | `[protected, virtual]`

| Bridge method for creating a <SVC_HANDLER>. The strategy for creating a <SVC_HANDLER> are configured into the Connector via it's <creation_strategy_>. The default is to create a new <SVC_HANDLER> only if <sh> == 0, else <sh> is unchanged. However, subclasses can override this policy to perform <SVC_HANDLER> creation in any way that they like (such as creating subclass instances of <SVC_HANDLER>, using a singleton, dynamically linking the handler, etc.). Returns -1 if failure, else 0. Reimplemented from ACE_Connector.

template<class SVC_HANDLER, ACE_PEER_CONNECTOR_1 >
virtual int ACE_Strategy_Connector< SVC_HANDLER, >::open | ( | ACE_Reactor * | r = ACE_Reactor::instance (),
|  | ACE_Creation_Strategy< SVC_HANDLER > * | = 0,
|  | ACE_Connect_Strategy< SVC_HANDLER, ACE_PEER_CONNECTOR_2 > * | = 0,
|  | ACE_Concurrency_Strategy< SVC_HANDLER > * | = 0,
|  | int | flags = 0
| ) | `[virtual]`

| Initialize a connector. <flags> indicates how <SVC_HANDLER>'s should be initialized prior to being activated. Right now, the only flag that is processed is <ACE_NONBLOCK>, which enabled non-blocking I/O on the <SVC_HANDLER> when it is opened.

template<class SVH, PR_CO_1 >
int ACE_Strategy_Connector< SVH, >::open | ( | ACE_Reactor * | r,
|  | int | flags
| ) | `[virtual]`

| Initialize a connector. <flags> indicates how <SVC_HANDLER>'s should be initialized prior to being activated. Right now, the only flag that is processed is <ACE_NONBLOCK>, which enabled non-blocking I/O on the <SVC_HANDLER> when it is opened. Default strategies would be created and used. Reimplemented from ACE_Connector.

## Member Data Documentation

template<class SVC_HANDLER, ACE_PEER_CONNECTOR_1 >
CONCURRENCY_STRATEGY* ACE_Strategy_Connector::concurrency_strategy_`[protected]`

| Concurrency strategy for an <Connector>.

template<class SVC_HANDLER, ACE_PEER_CONNECTOR_1 >
CONNECT_STRATEGY* ACE_Strategy_Connector::connect_strategy_`[protected]`

| Connect strategy for a <Connector>.

template<class SVC_HANDLER, ACE_PEER_CONNECTOR_1 >
CREATION_STRATEGY* ACE_Strategy_Connector::creation_strategy_`[protected]`

| Creation strategy for an <Connector>.

template<class SVC_HANDLER, ACE_PEER_CONNECTOR_1 >
int ACE_Strategy_Connector::delete_concurrency_strategy_`[protected]`

| 1 if <Connector> created the concurrency strategy and thus should delete it, else 0.

template<class SVC_HANDLER, ACE_PEER_CONNECTOR_1 >
int ACE_Strategy_Connector::delete_connect_strategy_`[protected]`

| 1 if <Connector> created the connect strategy and thus should delete it, else 0.

template<class SVC_HANDLER, ACE_PEER_CONNECTOR_1 >
int ACE_Strategy_Connector::delete_creation_strategy_`[protected]`

| 1 if <Connector> created the creation strategy and thus should delete it, else 0.

The documentation for this class was generated from the following files:

- Connector.h
- Connector.cpp